// HYDLIDE 3 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*18*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
	int num;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,d;
	unsigned char id1[]  = "HYD3 A-DISK Code";
	unsigned char id1b[] = "HYD3 AYXWVUTSRQP";
	unsigned char id2[] = "HYD3 B-DISK Code";
	unsigned char id3[] = "HYD3 UserDisk   ";

	// Disk A
	struct fpos md1[] =
	{
		{ 0x45, 0x0e, 0x0700,  3 },	// Out of freedom
		{ 0x0b, 0x0b, 0x0400, 10 },	// Mysterious Dimension
		{ 0x0b, 0x0f, 0x0400, 12 },	// Chaos separater
		{ 0x41, 0x08, 0x0700,  5 },	// Failyland
		{ 0x46, 0x03, 0x0700,  9 },	// Light Metal
		{ 0x0a, 0x11, 0x0200,  2 },	// Theme of Production
		{ 0x46, 0x0a, 0x0400,  6 },	// The Skyscraper
		{ 0x46, 0x0e, 0x0500,  8 },	// Dragon!!
		{ 0x41, 0x0f, 0x0600, 13 },	// Gayzac
		{ 0x47, 0x01, 0x0300,  4 },	// O.M.I.S.E
		{ 0x47, 0x04, 0x0400, 11 },	// Battle In The splash cave
		{ 0x00, 0x10, 0x0100,  7 },	// Game Over
		{ 0x00, 0x00, 0x0000,  0 }, // End of Data
	};

	// Disk B or User Disk
	struct fpos md2[] =
	{
		{ 0x48, 0x0d, 0x0a00,  1 },	// The Space Memories
		{ 0x49, 0x05, 0x0e00, 14 },	// Extinction
		{ 0x49, 0x0c, 0x0700, 15 },	// New Creator
//		{ 0x4e, 0x01, 0x0a00,  1 },	// LƑSf[^
//		{ 0x4e, 0x0b, 0x0e00, 14 },	// 
//		{ 0x4e, 0x12, 0x0700, 15 },	// 
		{ 0x00, 0x00, 0x0000,  0 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x12);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if (!memcmp(&buff[0xf0],id1,sizeof(id1)-1) || !memcmp(&buff[0xf0],id1b,sizeof(id1b)-1))
		{
			printf("Disk A F܂.\n");
			fcut("BIOS", 0x0a, 0x05, 0x00, 0x01, 0x01, 0x0000, 0x1300);
			for (i=0; md1[i].sec; i++)
			{
				sprintf(fname,"BGM%02d",md1[i].num);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, 0x0000, md1[i].size);
			}
			continue;
		}
		else if (!memcmp(&buff[0xf0],id2,sizeof(id2)-1))
		{
			printf("Disk B F܂.\n");
			for (i=0; md2[i].sec; i++)
			{
				sprintf(fname,"BGM%02d",md2[i].num);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
			continue;
		}
		else if (!memcmp(&buff[0xf0],id3,sizeof(id3)-1))
		{
			printf("User Disk F܂.\n");
			for (i=0; md2[i].sec; i++)
			{
				sprintf(fname,"BGM%02d",md2[i].num);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
			continue;
		}
	}
	return 0;
}

